Loading...
Searching...
No Matches
Halide::Internal::GeneratorInput_DynamicScalar< T > Class Template Reference

`#include <Generator.h>`

Inheritance diagram for Halide::Internal::GeneratorInput_DynamicScalar< T >:

## Public Member Functions

| GeneratorInput_DynamicScalar (const std::string &name)
| operator Expr () const
| You can use this Input as an expression in a halide function definition.
| operator ExternFuncArgument () const
| Using an Input as the argument to an external stage treats it as an Expr.
void | set_estimate (const Expr &value)
Type | type () const
Public Member Functions inherited from Halide::Internal::GeneratorInputImpl< T, Expr >
size_t | size () const
const Expr & | operator[] (size_t i) const
const Expr & | at (size_t i) const
std::vector< Expr >::const_iterator | begin () const
std::vector< Expr >::const_iterator | end () const
Public Member Functions inherited from Halide::Internal::GeneratorInputBase
| ~GeneratorInputBase () override
Public Member Functions inherited from Halide::Internal::GIOBase
virtual | ~GIOBase ()=default
void | set_type (const Type &type)
void | set_dimensions (int dims)
void | set_array_size (int size)
| GIOBase (const GIOBase &)=delete
GIOBase & | operator= (const GIOBase &)=delete
| GIOBase (GIOBase &&)=delete
GIOBase & | operator= (GIOBase &&)=delete

## Protected Member Functions

std::string | get_c_type () const override
Protected Member Functions inherited from Halide::Internal::GeneratorInputImpl< T, Expr >
bool | is_array () const override
| GeneratorInputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
| GeneratorInputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
| GeneratorInputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
Protected Member Functions inherited from Halide::Internal::GeneratorInputBase
| GeneratorInputBase (size_t array_size, const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
| GeneratorInputBase (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
Parameter | parameter () const
void | init_internals ()
void | set_inputs (const std::vector< StubInput > &inputs)
virtual void | set_def_min_max ()
void | verify_internals () override
void | check_value_writable () const override
const char * | input_or_output () const override
void | set_estimate_impl (const Var &var, const Expr &min, const Expr &extent)
void | set_estimates_impl (const Region &estimates)
Protected Member Functions inherited from Halide::Internal::GIOBase
bool | array_size_defined () const
size_t | array_size () const
const std::string & | name () const
ArgInfoKind | kind () const
bool | gio_types_defined () const
const std::vector< Type > & | gio_types () const
Type | gio_type () const
bool | dims_defined () const
int | dims () const
const std::vector< Func > & | funcs () const
const std::vector< Expr > & | exprs () const
| GIOBase (size_t array_size, const std::string &name, ArgInfoKind kind, const std::vector< Type > &types, int dims)
std::string | array_name (size_t i) const
void | check_matching_array_size (size_t size) const
void | check_matching_types (const std::vector< Type > &t) const
void | check_matching_dims (int d) const
template<typename ElemType>
const std::vector< ElemType > & | get_values () const
void | check_gio_access () const
template<>
const std::vector< Expr > & | get_values () const
template<>
const std::vector< Func > & | get_values () const

## Additional Inherited Members

Protected Types inherited from Halide::Internal::GeneratorInputImpl< T, Expr >
using | TBase
Protected Attributes inherited from Halide::Internal::GeneratorInputBase
std::vector< Parameter > | parameters_
bool | inputs_set = false
Protected Attributes inherited from Halide::Internal::GIOBase
int | array_size_
const std::string | name_
const ArgInfoKind | kind_
std::vector< Type > | types_
int | dims_
std::vector< Func > | funcs_
std::vector< Expr > | exprs_
GeneratorBase * | generator {nullptr}

## Detailed Description

template<typename T>
class Halide::Internal::GeneratorInput_DynamicScalar< T >

Definition at line 1951 of file Generator.h.

## Constructor & Destructor Documentation

## GeneratorInput_DynamicScalar()

template<typename T>

Halide::Internal::GeneratorInput_DynamicScalar< T >::GeneratorInput_DynamicScalar | ( | const std::string & | name | ) |

inline explicit

Definition at line 1963 of file Generator.h.

References Halide::Internal::GIOBase::name(), and Halide::Internal::Scalar.

## Member Function Documentation

## get_c_type()

template<typename T>

std::string Halide::Internal::GeneratorInput_DynamicScalar< T >::get_c_type | ( |  | ) | const

inline override protected virtual

Implements Halide::Internal::GeneratorInputBase.

Definition at line 1958 of file Generator.h.

## operator Expr()

template<typename T>

Halide::Internal::GeneratorInput_DynamicScalar< T >::operator Expr | ( |  | ) | const

inline

You can use this Input as an expression in a halide function definition.

Definition at line 1970 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access(), and Halide::Internal::GIOBase::exprs().

## operator ExternFuncArgument()

template<typename T>

Halide::Internal::GeneratorInput_DynamicScalar< T >::operator ExternFuncArgument | ( |  | ) | const

inline

Using an Input as the argument to an external stage treats it as an Expr.

Definition at line 1977 of file Generator.h.

References Halide::Internal::GeneratorInputImpl< T, Expr >::at(), Halide::Internal::GIOBase::check_gio_access(), and Halide::Internal::GIOBase::exprs().

## set_estimate()

template<typename T>

void Halide::Internal::GeneratorInput_DynamicScalar< T >::set_estimate | ( | const Expr & | value | ) |

inline

Definition at line 1982 of file Generator.h.

References Halide::Internal::GIOBase::check_gio_access(), Halide::Internal::GeneratorInputBase::parameters_, and Halide::Parameter::set_estimate().

## type()

template<typename T>

Type Halide::Internal::GeneratorInput_DynamicScalar< T >::type | ( |  | ) | const

inline

Definition at line 1989 of file Generator.h.

References Halide::Expr::type().

The documentation for this class was generated from the following file:

- src/Generator.h